class Interpolator(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  pyramid_levels : int
  fusion_pyramid_levels : int
  extract : __torch__.feature_extractor.FeatureExtractor
  predict_flow : __torch__.pyramid_flow_estimator.PyramidFlowEstimator
  fuse : __torch__.fusion.Fusion
  def forward(self: __torch__.interpolator.Interpolator,
    x0: Tensor,
    x1: Tensor,
    batch_dt: Tensor) -> Tensor:
    _0 = (self).debug_forward(x0, x1, batch_dt, )
    return (_0["image"])[0]
  def debug_forward(self: __torch__.interpolator.Interpolator,
    x0: Tensor,
    x1: Tensor,
    batch_dt: Tensor) -> Dict[str, List[Tensor]]:
    _1 = __torch__.util.flow_pyramid_synthesis
    image_pyramids = (self).shuffle_images(x0, x1, )
    extract = self.extract
    _2 = (extract).forward(image_pyramids[0], )
    extract0 = self.extract
    _3 = (extract0).forward(image_pyramids[1], )
    feature_pyramids = [_2, _3]
    predict_flow = self.predict_flow
    forward_residual_flow_pyramid = (predict_flow).forward(feature_pyramids[0], feature_pyramids[1], )
    predict_flow0 = self.predict_flow
    backward_residual_flow_pyramid = (predict_flow0).forward(feature_pyramids[1], feature_pyramids[0], )
    _4 = _1(forward_residual_flow_pyramid, )
    fusion_pyramid_levels = self.fusion_pyramid_levels
    forward_flow_pyramid = torch.slice(_4, None, fusion_pyramid_levels)
    _5 = _1(backward_residual_flow_pyramid, )
    fusion_pyramid_levels0 = self.fusion_pyramid_levels
    backward_flow_pyramid = torch.slice(_5, None, fusion_pyramid_levels0)
    mid_time = torch.full_like(batch_dt, 0.5)
    _6 = torch.select(torch.slice(mid_time), 1, 0)
    backward_flow = __torch__.util.multiply_pyramid(backward_flow_pyramid, _6, )
    _7 = torch.select(torch.slice(mid_time), 1, 0)
    forward_flow = __torch__.util.multiply_pyramid(forward_flow_pyramid, torch.add(torch.neg(_7), 1), )
    _8 = image_pyramids[0]
    fusion_pyramid_levels1 = self.fusion_pyramid_levels
    _9 = torch.slice(_8, None, fusion_pyramid_levels1)
    _10 = feature_pyramids[0]
    fusion_pyramid_levels2 = self.fusion_pyramid_levels
    _11 = torch.slice(_10, None, fusion_pyramid_levels2)
    _12 = __torch__.util.concatenate_pyramids(_9, _11, )
    _13 = image_pyramids[1]
    fusion_pyramid_levels3 = self.fusion_pyramid_levels
    _14 = torch.slice(_13, None, fusion_pyramid_levels3)
    _15 = feature_pyramids[1]
    fusion_pyramid_levels4 = self.fusion_pyramid_levels
    _16 = torch.slice(_15, None, fusion_pyramid_levels4)
    _17 = __torch__.util.concatenate_pyramids(_14, _16, )
    pyramids_to_warp = [_12, _17]
    forward_warped_pyramid = __torch__.util.pyramid_warp(pyramids_to_warp[0], backward_flow, )
    backward_warped_pyramid = __torch__.util.pyramid_warp(pyramids_to_warp[1], forward_flow, )
    aligned_pyramid = __torch__.util.concatenate_pyramids(forward_warped_pyramid, backward_warped_pyramid, )
    aligned_pyramid0 = __torch__.util.concatenate_pyramids(aligned_pyramid, backward_flow, )
    aligned_pyramid1 = __torch__.util.concatenate_pyramids(aligned_pyramid0, forward_flow, )
    fuse = self.fuse
    _18 = [(fuse).forward(aligned_pyramid1, )]
    _19 = {"image": _18, "forward_residual_flow_pyramid": forward_residual_flow_pyramid, "backward_residual_flow_pyramid": backward_residual_flow_pyramid, "forward_flow_pyramid": forward_flow_pyramid, "backward_flow_pyramid": backward_flow_pyramid}
    return _19
  def shuffle_images(self: __torch__.interpolator.Interpolator,
    x0: Tensor,
    x1: Tensor) -> List[List[Tensor]]:
    pyramid_levels = self.pyramid_levels
    _20 = __torch__.util.build_image_pyramid(x0, pyramid_levels, )
    pyramid_levels0 = self.pyramid_levels
    _21 = __torch__.util.build_image_pyramid(x1, pyramid_levels0, )
    return [_20, _21]
