def flow_pyramid_synthesis(residual_pyramid: List[Tensor]) -> List[Tensor]:
  _0 = __torch__.torch.nn.functional.___torch_mangle_66.interpolate
  flow = residual_pyramid[-1]
  flow_pyramid = [flow]
  _1 = torch.slice(residual_pyramid, None, -1)
  _2 = torch.slice(_1, None, None, -1)
  flow0 = flow
  for _3 in range(torch.len(_2)):
    residual_flow = _2[_3]
    level_size = torch.slice(torch.size(residual_flow), 2, 4)
    flow1 = _0(torch.mul(flow0, 2), level_size, None, "bilinear", None, None, False, )
    flow2 = torch.add(residual_flow, flow1)
    torch.insert(flow_pyramid, 0, flow2)
    flow0 = flow2
  return flow_pyramid
def multiply_pyramid(pyramid: List[Tensor],
    scalar: Tensor) -> List[Tensor]:
  _4 = annotate(List[Tensor], [])
  for _5 in range(torch.len(pyramid)):
    image = pyramid[_5]
    _6 = torch.append(_4, torch.mul(image, scalar))
  return _4
def concatenate_pyramids(pyramid1: List[Tensor],
    pyramid2: List[Tensor]) -> List[Tensor]:
  _7 = annotate(List[Tensor], [])
  _8 = [torch.len(pyramid1), torch.len(pyramid2)]
  for _9 in range(ops.prim.min(_8)):
    features1 = pyramid1[_9]
    features2 = pyramid2[_9]
    _10 = torch.cat([features1, features2], 1)
    _11 = torch.append(_7, _10)
  return _7
def pyramid_warp(feature_pyramid: List[Tensor],
    flow_pyramid: List[Tensor]) -> List[Tensor]:
  _12 = annotate(List[Tensor], [])
  _13 = [torch.len(feature_pyramid), torch.len(flow_pyramid)]
  for _14 in range(ops.prim.min(_13)):
    features = feature_pyramid[_14]
    flow = flow_pyramid[_14]
    _15 = __torch__.util.warp(features, flow, )
    _16 = torch.append(_12, _15)
  return _12
def build_image_pyramid(image: Tensor,
    pyramid_levels: int=3) -> List[Tensor]:
  _17 = annotate(List[Tensor], [])
  image0 = image
  for i in range(pyramid_levels):
    _18 = torch.append(_17, image0)
    _19 = torch.lt(i, torch.sub(pyramid_levels, 1))
    if _19:
      image2 = torch.avg_pool2d(image0, [2, 2], [2, 2])
      image1 = image2
    else:
      image1 = image0
    image0 = image1
  return _17
def warp(image: Tensor,
    flow: Tensor) -> Tensor:
  _20 = __torch__.torch.nn.functional.grid_sample
  flow3 = torch.neg(torch.flip(flow, [1]))
  dtype = ops.prim.dtype(flow3)
  device = ops.prim.device(flow3)
  ls1 = torch.sub(1, torch.div(1, (torch.size(flow3))[3]))
  ls2 = torch.sub(1, torch.div(1, (torch.size(flow3))[2]))
  _21 = torch.permute(flow3, [0, 2, 3, 1])
  _22 = torch.mul((torch.size(flow3))[2], 0.5)
  _23 = torch.mul((torch.size(flow3))[3], 0.5)
  _24 = torch.tensor([_22, _23], dtype=dtype, device=device)
  _25 = torch.unsqueeze(torch.unsqueeze(_24, 0), 1)
  normalized_flow2 = torch.div(_21, torch.unsqueeze(_25, 2))
  _26 = torch.linspace(torch.neg(ls1), ls1, (torch.size(flow3))[3], dtype=dtype, layout=None, device=device)
  _27 = torch.unsqueeze(torch.unsqueeze(_26, 0), 1)
  _28 = torch.sub(torch.slice(_27, 2), torch.select(normalized_flow2, -1, 1))
  _29 = torch.linspace(torch.neg(ls2), ls2, (torch.size(flow3))[2], dtype=dtype, layout=None, device=device)
  _30 = torch.slice(torch.unsqueeze(_29, 0), 1)
  _31 = torch.sub(torch.unsqueeze(_30, 2), torch.select(normalized_flow2, -1, 0))
  normalized_flow20 = torch.stack([_28, _31], 3)
  warped = _20(image, normalized_flow20, "bilinear", "border", False, )
  _32 = torch.reshape(warped, torch.size(image))
  return _32
